//+------------------------------------------------------------------+
//|                                                   Magic_exp2.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
class CProvision
  {
protected:
   MqlTradeRequest   trades;//      OrderSend
public:
   int               TYPE(const double &v[]); //  ,     
   double            pricetype(int type);     //        
   double            SLtype(int type);        //       
   double            TPtype(int type);        //       
   long              spread();                //    
   ulong             SendOrder(ENUM_ORDER_TYPE type,double volume);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ulong CProvision::SendOrder(ENUM_ORDER_TYPE type,double volume)
  {
   trades.action=TRADE_ACTION_DEAL;      //   
   trades.magic=magic;//   ( magic number)  magic  
                      //mg.SetMagic_request(digital_name_,code_interaction_);
   trades.symbol          =_Symbol;                //   
   trades.volume          =volume;                 //     
   trades.price           =pricetype((int)type);   //        
   trades.sl              =SLtype((int)type);      //  Stop Loss 
   trades.tp              =TPtype((int)type);      //  Take Profit          
   trades.deviation=(int)spread();                 //      
   trades.type=type;                               //  
   trades.type_filling=ORDER_FILLING_FOK;
   if(OrderSend(trades,res)){return(res.retcode);}
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CProvision::TYPE(const double &v[])//  ,     
  {
   double t=v[0]-v[1];//           
   if(t==0.0)t=1.0;//           
   return((int)(0.5*t/fabs(t)+0.5));//     0(),   1()
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CProvision::pricetype(int type)//        
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.ask);
      if(type==1)return(tick.bid);
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CProvision::SLtype(int type)//       
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.bid-SL*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
      if(type==1)return(tick.ask+SL*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CProvision::TPtype(int type)//       
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.bid+TP*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
      if(type==1)return(tick.ask-TP*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
long CProvision::spread()//  
  {
   return(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum Emagic
  {
   ENUM_DIGITAL_NAME,    //   
   ENUM_CODE_INTERACTION,//  
   ENUM_EXPERT_SYMBOL    //     
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct Smagic
  {
   ulong             magicnumber;      //         
   int               digital_name;     //  
   int               code_interaction; //  
   int               expert_symbol;    //     
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct SPositionVirtualMagic
  {
   double            volume;
   ENUM_POSITION_TYPE type;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class Cmagic
  {
protected:
   Smagic            mag;
   SPositionVirtualMagic pvm;
public:
   ulong             SetMagic_request(int digital_name=0,int code_interaction=0);
   // .       
   ulong             SetMagic_result(ulong magicnumber);
   // .           
   ulong             GetMagic_result(Emagic enum_);
   // .         
   string            sGetMagic_result(Emagic enum_);
   // .           
   double               cVOLUME(){return(pvm.volume);}
   //     
   ENUM_POSITION_TYPE   cTYPE(){return(pvm.type);}
   //       
   bool              PositionVirtualMagic(//const ulong Magic,
                                          Emagic enum_,
                                          string symbol,
                                          datetime CurrentTime);
   //   . ,     . 
private:
   int               decodeMagic_result(int category);
   // .                category
   int               symbolexpert();
   //      
   string            expertcode(int code);
   //      ()
   string            codeinterdescript(int code);
   //      ()
   string            symbolexpert(int code);
   //      
   void              prHistory_Deals(ulong &buf[],int HTD);
   //   
  };
//+------------------------------------------------------------------+
//|   . ,     .  |
//+------------------------------------------------------------------+
bool  Cmagic::PositionVirtualMagic(Emagic enum_,
                                   string symbol,
                                   datetime CurrentTime)
  {
   ulong Magic=GetMagic_result(enum_);
   int DIGITS=(int)-log10(SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP)); if(DIGITS<0)DIGITS=0;
   ulong Dticket=0;
   int History_Total_Deals=-1;
   double volume=0,volume_BUY=0,volume_SELL=0;
   ulong DTicketbuf[];

   do
     {
      if(HistorySelect(0,TimeCurrent()))
        {
         History_Total_Deals=HistoryDealsTotal();
         prHistory_Deals(DTicketbuf,History_Total_Deals);
        }
      HistorySelect(0,TimeCurrent());
     }
   while(History_Total_Deals!=HistoryDealsTotal());

   for(int t=0;t<History_Total_Deals;t++)
     {
      Dticket=DTicketbuf[t];
      if(HistoryDealSelect(Dticket))
        {
         if(HistoryDealGetInteger(Dticket,DEAL_TIME)>=CurrentTime)
           {
            if(HistoryDealGetString(Dticket,DEAL_SYMBOL)==symbol)
              {
               SetMagic_result(HistoryDealGetInteger(Dticket,DEAL_MAGIC));
               if(GetMagic_result(enum_)==Magic)
                 {
                  if(HistoryDealGetInteger(Dticket,DEAL_TYPE)==DEAL_TYPE_BUY)
                    {
                     volume_BUY+=HistoryDealGetDouble(Dticket,DEAL_VOLUME);
                    }
                  else
                    {
                     if(HistoryDealGetInteger(Dticket,DEAL_TYPE)==DEAL_TYPE_SELL)
                       {
                        volume_SELL+=HistoryDealGetDouble(Dticket,DEAL_VOLUME);
                       }
                    }
                 }
              }
           }
        }
      else{HistorySelect(0,TimeCurrent());t--;}
      //         
     }
   volume=NormalizeDouble(volume_BUY-volume_SELL,DIGITS);
   if(volume<0)pvm.type=POSITION_TYPE_SELL;
   else
     {
      if(volume>0)pvm.type=POSITION_TYPE_BUY;
     }
   pvm.volume=fabs(volume); //Print("",magic," #",Magic," pvm.volume ",pvm.volume," pvm.type ",pvm.type);
   if(pvm.volume==0)return(false);
   else return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void  Cmagic::prHistory_Deals(ulong &buf[],int HTD)
  {
   ArrayResize(buf,HTD);
   for(int t=0;t<HTD;t++)
     {
      buf[t]=HistoryDealGetTicket(t);
     }
  }
//+------------------------------------------------------------------+
//| .               |
//+------------------------------------------------------------------+
ulong Cmagic::SetMagic_request(int digital_name=0,int code_interaction=0)
  {
   if(digital_name>=1000)Print("     ( 1000)");
   if(code_interaction>=1000)Print("     -( 1000)");
   mag.digital_name     =digital_name;
   mag.code_interaction =code_interaction;
   mag.expert_symbol    =symbolexpert();
   mag.magicnumber      =mag.digital_name*(int)pow(1000,2)+mag.code_interaction*(int)pow(1000,1)+mag.expert_symbol;
   return(mag.magicnumber);
  }
//+------------------------------------------------------------------+
//| .            |
//+------------------------------------------------------------------+
ulong Cmagic::SetMagic_result(ulong magicnumber)
  {
   mag.magicnumber      =magicnumber;
   mag.expert_symbol    =decodeMagic_result(1);
   mag.code_interaction =decodeMagic_result(2);
   mag.digital_name     =decodeMagic_result(3);
   return(mag.magicnumber);
  }
//+------------------------------------------------------------------+
//| .                category |
//+------------------------------------------------------------------+
int Cmagic::decodeMagic_result(int category)
  {
   string string_value=(string)mag.magicnumber;
   int rem=(int)MathMod(StringLen(string_value),3);
   if(rem!=0)
     {
      rem=3-rem;
      string srem="0";
      if(rem==2)srem="00";
      string_value=srem+string_value;
     }
   int start_pos=StringLen(string_value)-3*category;
   string value=StringSubstr(string_value,start_pos,3);
   return((int)StringToInteger(value));
  }
//+------------------------------------------------------------------+
//| .          |
//+------------------------------------------------------------------+
ulong Cmagic::GetMagic_result(Emagic enum_)
  {
   switch(enum_)
     {
      case ENUM_DIGITAL_NAME     : return(mag.digital_name);     break;
      case ENUM_CODE_INTERACTION : return(mag.code_interaction); break;
      case ENUM_EXPERT_SYMBOL    : return(mag.expert_symbol);    break;
      default: return(mag.magicnumber); break;
     }
  }
//+------------------------------------------------------------------+
//| .            |
//+------------------------------------------------------------------+
string Cmagic::sGetMagic_result(Emagic enum_)
  {
   switch(enum_)
     {
      case ENUM_DIGITAL_NAME     : return(expertcode(mag.digital_name));            break;
      case ENUM_CODE_INTERACTION : return(codeinterdescript(mag.code_interaction)); break;
      case ENUM_EXPERT_SYMBOL    : return(symbolexpert(mag.expert_symbol));         break;
      default: return((string)mag.magicnumber); break;
     }
  }
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
int Cmagic::symbolexpert()
  {
   if("EURUSD"==Symbol()){return(1);}
   if("GBPUSD"==Symbol()){return(2);}
   if("USDCHF"==Symbol()){return(3);}
   if("USDJPY"==Symbol()){return(4);}
   if("USDCAD"==Symbol()){return(5);}
   if("AUDUSD"==Symbol()){return(6);}
   if("AUDNZD"==Symbol()){return(7);}
   if("AUDCAD"==Symbol()){return(8);}
   if("AUDCHF"==Symbol()){return(9);}
   if("AUDJPY"==Symbol()){return(10);}
   if("CHFJPY"==Symbol()){return(11);}
   if("EURGBP"==Symbol()){return(12);}
   if("EURAUD"==Symbol()){return(13);}
   if("EURCHF"==Symbol()){return(14);}
   if("EURJPY"==Symbol()){return(15);}
   if("EURNZD"==Symbol()){return(16);}
   if("EURCAD"==Symbol()){return(17);}
   if("GBPCHF"==Symbol()){return(18);}
   if("GBPJPY"==Symbol()){return(19);}
   if("CADCHF"==Symbol()){return(20);}
   if("#AA"==Symbol()){return(21);}
   if("#AIG"==Symbol()){return(22);}
   if("#AXP"==Symbol()){return(23);}
   if("#BA"==Symbol()){return(24);}
   if("#BAC"==Symbol()){return(25);}
   if("#C"==Symbol()){return(26);}
   if("#CAT"==Symbol()){return(27);}
   if("#CVX"==Symbol()){return(28);}
   if("#DD"==Symbol()){return(29);}
   if("#DIS"==Symbol()){return(30);}
   if("#EK"==Symbol()){return(31);}
   if("#GE"==Symbol()){return(32);}
   if("#HD"==Symbol()){return(33);}
   if("#HON"==Symbol()){return(34);}
   if("#HPQ"==Symbol()){return(35);}
   if("#IBM"==Symbol()){return(36);}
   if("#INTC"==Symbol()){return(37);}
   if("#IP"==Symbol()){return(38);}
   if("#JNJ"==Symbol()){return(39);}
   if("#JPM"==Symbol()){return(40);}
   if("#KFT"==Symbol()){return(41);}
   if("#KO"==Symbol()){return(42);}
   if("#MCD"==Symbol()){return(43);}
   if("#MMM"==Symbol()){return(44);}
   if("#MO"==Symbol()){return(45);}
   if("#MRK"==Symbol()){return(46);}
   if("#MSFT"==Symbol()){return(47);}
   if("#PFE"==Symbol()){return(48);}
   if("#PG"==Symbol()){return(49);}
   if("#T"==Symbol()){return(50);}
   if("#TRV"==Symbol()){return(51);}
   if("#UTX"==Symbol()){return(52);}
   if("#VZ"==Symbol()){return(53);}
   if("#WMT"==Symbol()){return(54);}
   if("#XOM"==Symbol()){return(55);}
   if("NZDUSD"==Symbol()){return(56);}
   if("USDRUR"==Symbol()){return(57);}
   if("EURRUR"==Symbol()){return(58);}
   if("USDSEK"==Symbol()){return(59);}
   return(-1);
  }
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
string Cmagic::symbolexpert(int code)
  {
   if(code==1){return("EURUSD");}
   if(code==2){return("GBPUSD");}
   if(code==3){return("USDCHF");}
   if(code==4){return("USDJPY");}
   if(code==5){return("USDCAD");}
   if(code==6){return("AUDUSD");}
   if(code==7){return("AUDNZD");}
   if(code==8){return("AUDCAD");}
   if(code==9){return("AUDCHF");}
   if(code==10){return("AUDJPY");}
   if(code==11){return("CHFJPY");}
   if(code==12){return("EURGBP");}
   if(code==13){return("EURAUD");}
   if(code==14){return("EURCHF");}
   if(code==15){return("EURJPY");}
   if(code==16){return("EURNZD");}
   if(code==17){return("EURCAD");}
   if(code==18){return("GBPCHF");}
   if(code==19){return("GBPJPY");}
   if(code==20){return("CADCHF");}
   if(code==21){return("#AA");}
   if(code==22){return("#AIG");}
   if(code==23){return("#AXP");}
   if(code==24){return("#BA");}
   if(code==25){return("#BAC");}
   if(code==26){return("#C");}
   if(code==27){return("#CAT");}
   if(code==28){return("#CVX");}
   if(code==29){return("#DD");}
   if(code==30){return("#DIS");}
   if(code==31){return("#EK");}
   if(code==32){return("#GE");}
   if(code==33){return("#HD");}
   if(code==34){return("#HON");}
   if(code==35){return("#HPQ");}
   if(code==36){return("#IBM");}
   if(code==37){return("#INTC");}
   if(code==38){return("#IP");}
   if(code==39){return("#JNJ");}
   if(code==40){return("#JPM");}
   if(code==41){return("#KFT");}
   if(code==42){return("#KO");}
   if(code==43){return("#MCD");}
   if(code==44){return("#MMM");}
   if(code==45){return("#MO");}
   if(code==46){return("#MRK");}
   if(code==47){return("#MSFT");}
   if(code==48){return("#PFE");}
   if(code==49){return("#PG");}
   if(code==50){return("#T");}
   if(code==51){return("#TRV");}
   if(code==52){return("#UTX");}
   if(code==53){return("#VZ");}
   if(code==54){return("#WMT");}
   if(code==55){return("#XOM");}
   if(code==56){return("NZDUSD");}
   if(code==57){return("USDRUR");}
   if(code==58){return("EURRUR");}
   if(code==59){return("USDSEK");}
   return("NONE");
  }
//+------------------------------------------------------------------+
//|      ()       |
//+------------------------------------------------------------------+
string Cmagic::expertcode(int code)
  {
   if(code==1){return("MACD");}
   if(code==2){return("MA20");}
   if(code==3){return("-\\-");}
   if(code==4){return("-\\-");}
   if(code==5){return("-\\-");}
   if(code==6){return("-\\-");}
   if(code==7){return("-\\-");}
   if(code==8){return("-\\-");}
   if(code==9){return("-\\-");}
   if(code==10){return("-\\-");}
   if(code==11){return("-\\-");}
   if(code==12){return("-\\-");}
   if(code==13){return("-\\-");}
   if(code==14){return("-\\-");}
   if(code==15){return("-\\-");}
   return("NONE");
  }
//+------------------------------------------------------------------+
//|      ()  |
//+------------------------------------------------------------------+
string Cmagic::codeinterdescript(int code)
  {
   if(code==1){return("MACD+MA20");}
   if(code==2){return("-\\-");}
   if(code==3){return("-\\-");}
   if(code==4){return("-\\-");}
   if(code==5){return("-\\-");}
   if(code==6){return("-\\-");}
   if(code==7){return("-\\-");}
   if(code==8){return("-\\-");}
   if(code==9){return("-\\-");}
   if(code==10){return("-\\-");}
   if(code==11){return("-\\-");}
   if(code==12){return("-\\-");}
   if(code==13){return("-\\-");}
   if(code==14){return("-\\-");}
   if(code==15){return("-\\-");}
   return("NONE");
  }
//+------------------------------------------------------------------+
//|XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX|
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+

//--- input parameters
input ulong              digital_name_       =4;           //   
input ulong              code_interaction_   =1;           //  
input Emagic             _enum               =0;           //    
input int                SL                  =300;         // 
input int                TP                  =1000;        // 
input int                MA_Period           =25;          //  MA
input double             lot                 =0.4;         //  
input int                MA_shift            =0;           //  
input ENUM_MA_METHOD     MA_smooth           =MODE_SMA;    //  
input ENUM_APPLIED_PRICE price               =PRICE_OPEN;  //   

//---    
int MA_handle,type_MA;
ulong rezult;
static ulong magic;
double v[2];
datetime  CurrentTime;//     

MqlTradeResult  res;   //      OrderSend
MqlTick         tick;  //      
CProvision prov;
Cmagic mg;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   magic=mg.SetMagic_request(int(digital_name_),int(code_interaction_));
//   ( magic number)  magic  
//      int CProvision::SendOrder(ENUM_ORDER_TYPE type,double volume)
   CurrentTime=TimeCurrent();//     
//---   
   MA_handle=iMA(Symbol(),0,MA_Period,MA_shift,MA_smooth,price);
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(CopyBuffer(MA_handle,0,0,2,v)<=0)
     {Print("",magic," ");return;}
   type_MA=prov.TYPE(v); //  ,     
   mg.SetMagic_result(magic);//    
   if(mg.PositionVirtualMagic(_enum,_Symbol,CurrentTime))//     
     {
      if((int)mg.cTYPE()!=type_MA)//    
        {
         mg.SetMagic_result(magic);//    
         Print("",mg.GetMagic_result(_enum),"     ",mg.cVOLUME(),
               "    ",(int)mg.cTYPE(),"  ",type_MA);
         //cpvm.cVOLUME() -   
         rezult=prov.SendOrder((ENUM_ORDER_TYPE)type_MA,mg.cVOLUME()+lot);//  
         if(rezult!=-1)Print("",magic,"   ",rezult," volume ",res.volume);
         else{Print("",magic,"",GetLastError()); return;}
        }
     }
   else //     
     {
      Print("",magic,"     ",mg.cVOLUME(),"    ",type_MA);
      rezult=prov.SendOrder((ENUM_ORDER_TYPE)type_MA,lot);//   
      if(rezult!=-1)Print("",magic,"   ",rezult," volume ",res.volume);
      else{Print("",magic,"",GetLastError()); return;}
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+ 

//text789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
//cod456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_12
